DECLARE SUB InputFiles ()
DECLARE SUB FCount (X$, X%)
DECLARE SUB BasDir (BYVAL X%)

10 ' FLUE SIMULATOR DYNAMIC ANALYSIS PROGRAM   BY SCANADA CONSULTANTS LIMITED        VERSION 5.0    12/89
'$INCLUDE: 'FLUECOMM.BAS'
DIM VAR(20), VA$(20)
DIM FTP$(4), SCRFT$(4), SCRFT1$(4), SCRCT$(4), CTYP$(4)
DIM A$(80), B$(80), C$(80), TMTL$(20), PRTL$(20), FLTL$(10)
'
DIM S.ASC%(255), S.NUM%(26), S.ALT%(132), S.LIB$(50), S.LB%(50), S.LD%(50)
DIM SI.POS%(64, 2), SI.LEN%(64), SI.TYP$(64), SI.AID$(64), SI.AIDS$(64)
DIM SI.DATA$(64), SI.TMP$(64), SI.DF$(64), SI.TBL$(64), SI.RG#(64, 2)
DIM SI.FLG%(64), SI.DP%(64)
DIM SO.POS%(192, 2), SO.COL%(192, 2), SO.TXT$(192)
DIM DBP%(128), DBFT%(8, 64), DBF$(64)
'
DIM SHARED FileName$(60)
'
COMMON S.ASC%(), S.NUM%(), S.ALT%(), S.LIB$(), S.LB%(), S.LD%()
COMMON SI.POS%(), SI.LEN%(), SI.TYP$(), SI.AID$(), SI.AIDS$(), SI.DATA$()
COMMON SI.TMP$(), SI.DF$(), SI.TBL$(), SI.RG#(), SI.FLG%(), SI.DP%()
COMMON SO.POS%(), SO.COL%(), SO.TXT$(), S.M%, SHC%, S.X%, S.Y%
COMMON DBP%(), DBFT%(), DBF$()

COMMON SHARED DefaultFile$

DEF FNC# (A#, D%) = FIX((A# + 5 * SGN(A#) * 10 ^ (-D% - 1)) * 10 ^ D%) / 10 ^ D%
DEF FNA# (A#, B#, D%) = FNC#(FNC#(A#, D%) + FNC#(B#, D%), D%): DEF FNS# (A#, B#, D%) = FNC#(FNC#(A#, D%) - FNC#(B#, D%), D%): DEF FNM# (A#, B#, D%) = FNC#(FNC#(A#, D%) * FNC#(B#, D%), D%): DEF FND# (A#, B#, D%) = FNC#(FNC#(A#, D%) / FNC#(B#, D%), D% _
)
DEF FNS.C! (X!, Y%) = FIX((X! + 5 * SGN(X!) * 10 ^ (-Y% - 1)) * 10 ^ Y%) / 10 ^ Y%

99 FTP$(1) = "O": FTP$(2) = "O": FTP$(3) = "G": FTP$(4) = "G"
100 SCRFT$(1) = "OILINT": SCRFT$(2) = "OILEXT": SCRFT$(3) = "GASINT": SCRFT$(4) = "GASEXT"
101 SCRFT1$(1) = "OIFURN": SCRFT1$(2) = "OIFURN": SCRFT1$(3) = "GAFURN": SCRFT1$(4) = "GAFURN"
110 SCRCT$(1) = "CHIM#2": SCRCT$(2) = "CHIM#3": SCRCT$(3) = "CHIM#4": SCRCT$(4) = "CHIM#5"
111 ON ERROR GOTO 29000
112 OPEN "INSTALL5.DAT" FOR INPUT AS #3
113 INPUT #3, IGRAPH, DRIVE$, IOUT, INDRIVE$
114 CLOSE #3
116 Z$ = "N": FLUEIN$ = "FLUEIN5"
119 CTYP$(1) = "UNLINED MASONRY": CTYP$(2) = "A-VENT": CTYP$(3) = "B-VENT": CTYP$(4) = "LINED MASONRY"
120 WCOEFH(1) = .1: WCOEFH(2) = .2: WCOEFH(3) = .3: WCOEFH(4) = .4: WCOEFH(5) = .5: WCOEFH(6) = .5
130 WCOEFV(1) = 0!: WCOEFV(2) = .2: WCOEFV(3) = .4: WCOEFV(4) = .6: WCOEFV(5) = .8: WCOEFV(6) = 1!
500 GOSUB 4000 ' MAIN PROGRAM
600 CLOSE : COLOR 7, 0: CLS : END
1000 REM *** INITIALIZE ***
1100 SHC$ = "INI,1," + LIBT$ + ".SLB": GOSUB 40000: IF S.ERR% THEN PRINT "SCREEN HANDLER ERROR WHILE OPENING LIBRARY": STOP
1120 SHC$ = "ELC/EFK,2": GOSUB 40000' ENABLE LOWER CASE AND FUNCTION KEY 2
1990 RETURN
2000 REM *** PROCESS MAIN SCREEN ***
2010 SHC$ = "DIS," + SCRTL$ + "/CIF": GOSUB 40000
2020 GOSUB 3000 ' SET DEFAULTS
2030 SHC$ = "DIF": GOSUB 40000 ' DISPLAY FIELD VALUES AND DEFAULTS
2050 SHC$ = "EFK,3/INP/DFK,3": GOSUB 40000
2060 IF S.RC% = 2 THEN 2990
2070 IF S.RC% = 3 THEN SHC$ = "MSG,FUNCTION KEY 3 PRESSED": GOSUB 40000: GOTO 2050
2100 'SHC$="MGV,PROCESS COMPLETED. PRESS ANY KEY FOR ANOTHER SCREEN": GOSUB 40000
2200 COLOR 7, 0
2990 RETURN
3000 REM *** SET NUMERIC FIELDS ON SCREEN ***
3005 FOR S.F% = 1 TO NF%
3007 IF VAR(S.F%) = -9997 THEN GOTO 3020
3010 'S.VAL#=VAR(S.F%): GOSUB 55300: SI.DF$(S.F%)=SI.DATA$(S.F%): GOTO 3080
3015 X$ = STR$(FNC#(VAR(S.F%), SI.DP%(S.F%))): GOSUB 3500: LSET SI.DATA$(S.F%) = X$: SI.DF$(S.F%) = SI.DATA$(S.F%): GOTO 3080
3020 LSET SI.DATA$(S.F%) = VA$(S.F%): SI.DF$(S.F%) = SI.DATA$(S.F%)
3080 NEXT
3090 RETURN
3500 REM *** CONVERT NUMBER ***
3510 X% = INSTR(X$, "."): IF X% = 0 THEN X$ = X$ + ".": X% = LEN(X$)
3515 IF SI.DP%(S.F%) > 6 THEN SI.DP%(S.F%) = 5
3520 X$ = LEFT$(X$ + STRING$(SI.DP%(S.F%), "0"), X% + SI.DP%(S.F%))
3530 IF LEFT$(X$, 1) = " " THEN X$ = MID$(X$, 2)
3590 RETURN
3999 '
4000 '   MAIN INPUT PROGRAM
4001 '
4160 IF MASTER% = 1234 THEN GOTO 4280
4170 TLFLAG% = 0: PCODE% = 1: KEY OFF: ENTRY% = 0: WIDTH "lpt1:", 233
4180 ON ERROR GOTO 29100
4200 REM    DEVELOPED BY: SCANADA CONSULTANTS LIMITED FOR CANADA MORTGAGE & HOUSING CORPORATION
4210 REM    PROGRAM DESIGN & CODING: MICHAEL C. SWINTON
4220 REM                             MICHAEL D. MONETTE
4230 REM                             ROBIN P. SINHA
4235 REM                             ANIL J. PAREKH
4238 REM
4240 REM                             DATES: OCTOBER, 1984;  JUNE 1986, DECEMBER 1989
4250 REM    FLUEPIPE REVISIONS-MAY 15, 1986 BY RPS
4251 REM    FLUESIM MODULARIZATION - DECEMBER 1989 BY J.R. YVES LEMOINE
4260 REM                                              ANIL J. PAREKH
4270 PRFLAG% = 0
4280 REM  INTIALIZATION OF VARIABLES
4290 FOR AA% = 1 TO 10: CHM$(AA%) = " ": NEXT AA%
4300 LIBT$ = "FLUE-G5": GOSUB 1000
4305 IF MASTER% = 1234 THEN GOTO 4380
4310 SCRTL$ = "WELCOM"
4320 NF% = 1
4330 FOR I% = 1 TO NF%: VAR(I%) = -9997: NEXT
4340 VA$(1) = " "
4350 GOSUB 2000
4360 GOTO 4530
4380 REM:
4390 CLS : PRINT : PRINT
4400 COLOR 15: PRINT "FLUE SIMULATOR DYNAMIC ANALYSIS PROGRAM "
4402 PRINT "======================================="
4403 PRINT : PRINT "SCANADA CONSULTANTS LIMITED": PRINT "VERSION 5.0 - DECEMBER 1989"
4410 PRINT : COLOR 15, 0: PRINT "COMMAND MENU": PRINT : COLOR 7
4420 PRINT TAB(5); "1-CHANGE FILE DATA"
4430 PRINT TAB(5); "2-SET RUN TIME CONTROLS"
4440 PRINT TAB(5); "3-CHOOSE GRAPHICS FORMATS OR PRINT CONTROLS"
4450 PRINT TAB(5); "4-SAVE FILE"
4460 PRINT TAB(5); "5-RUN PROGRAM"
4470 PRINT TAB(5); "6-CONTINUE OR EXTEND SIMULATION"
4475 PRINT TAB(5); "7-LOAD ANOTHER DATA FILE"
4480 PRINT TAB(5); "8-QUIT"
4490 COLOR 15, 0: PRINT : INPUT "YOUR SELECTION (NUMBER FROM 1 TO 8) --> "; SS$: COLOR 7: IF VAL(SS$) < 1 OR VAL(SS$) > 8 THEN GOTO 4390
4500 SS = VAL(SS$)
4520 ON SS GOTO 5000, 8900, 9030, 4750, 5170, 5210, 4530, 5920
4530 REM: LOAD FILE ROUTINE
4540 ENTRY% = 1

CALL InputFiles

4553 FLE$ = DefaultFile$ + ".FM5"
4554 CHK$ = ".": LOCDOT = INSTR(FLE$, CHK$): FAULT$ = LEFT$(FLE$, LOCDOT - 1)
4555 IF IOUT = 2 OR IGRAPH = 1 THEN OU$ = DRIVE$ + FAULT$ + ".PRN" ELSE OU$ = "LPT1:"
4556 '
4557 OPEN INDRIVE$ + FLE$ FOR INPUT AS #2
4581 DOC$ = FLE$
4590 FOR AA% = 1 TO 19
4600 INPUT #2, HT(AA%), AR(AA%), TN(AA%)
4610 NEXT AA%
4620 INPUT #2, NE%, NELBOWS, NFPSEGS%, TFPLN
4630 FOR FPSEG% = 1 TO NFPSEGS%: INPUT #2, RISE(FPSEG%), FPLN(FPSEG%): NEXT FPSEG%
4640 FOR AA% = 2 TO 4: FOR BB% = 1 TO NE%: INPUT #2, DI2(AA%, BB%), HC(AA%, BB%): NEXT BB%: NEXT AA%
4650 FOR AA% = 1 TO NE%: INPUT #2, ELTL(AA%), ELTS(AA%), ELTO(AA%), DENL(AA%), DENS(AA%), DENO(AA%), THCL(AA%), THCS(AA%), THCO(AA%): NEXT AA%
4660 FOR AA% = 1 TO 4: FOR BB% = 1 TO NE%: INPUT #2, TI(AA%, BB%): NEXT BB%: NEXT AA%
4670 INPUT #2, APRD, FICV, TCF2, F2, F1, SSEFF, TSSGE, CHIMT$, CHBOT, XPT
4680 INPUT #2, LNPP, LHC, C, N, T1, T9, VWIND, T6F, TMF, T7F, SCS, SEC, Z2, FS, AUFF, ST, PRFF$, PRCOND$, PRREG$, TITLE$, MOHE, HCHE, M2CP, QF, FP, VWINDH, VWINDV, FT$, SCSFLAG%
4690 INPUT #2, FPDI2(2), FPDI2(3), FPDI2(4), FPHC(2), FPHC(3), FPHC(4), FPELTL, FPELTS, FPELTO, FPDENL, FPDENS, FPDENO, FPTHCL, FPTHCS, FPTHCO
4700 INPUT #2, CHDI2(2), CHDI2(3), CHDI2(4), CHHC(2), CHHC(3), CHHC(4), CHELTL, CHELTS, CHELTO, CHDENL, CHDENS, CHDENO, CHTHCL, CHTHCS, CHTHCO
4705 INPUT #2, EXAIR, ARINT, VCLINT, NELINT, LEAKDIST, ICHTYPE%
4706 INPUT #2, DHWC, DHWSBC, DHWEF, DHWAR, DHWFPLE, DHWFPH, DHWNEL, DHWTYPE$, DHWFPN, DHWO$, FDAMP$, ARDAMP, FCAPL, DAMPACT$, DAMPTOP, DAMPTCL
4707 INPUT #2, TMONOFF, HVOL, HTC, HMASS$, MDI$, P$, GD$
4708 INPUT #2, NDHWFP%, TDHW, PHC, THETAW, PTC, VWINDT, FL1%, FL2%, TMP1%, TMP2%, TMP3%, TMP4%, P1%, P2%, P3%, P4%, FR1%, FR2%, FR3%, FR4%
4709 FOR AA% = 1 TO NDHWFP%
4710 FOR J% = 1 TO 5
4711 INPUT #2, TIDHW(J%, AA%)
4712 NEXT J%: NEXT AA%
4714 IF GD$ = "T" OR IGRAPH = 2 THEN FL1% = 0 ELSE FL1% = 1
4715 THS = T9 + (TMONOFF / 2)
4716 FPFLAG% = 1: PRFLAG2% = 0
4717 IF MDI$ = "Y" THEN GOSUB 12740
4718 IF EOF(2) THEN GOTO 4720
4719 INPUT #2, OU$
4720 CLOSE #2: COLOR 7
4730 FOR AA% = 1 TO 10: CHM$(AA%) = " ": NEXT AA%
4740 GOTO 4390
4750 REM: SAVE FILE ROUTINE
4760 HDR$ = "INPUT FILE SAVE ROUTINE": QN1$ = "ENTER THE NAME OF THE DISK FILE TO STORE THIS SET UP DATA": TFLAG = 1: TLEN = 8: QN2$ = "(EXTENSION '.FM5' IS AUTOMATICALLY ADDED)"
4770 FAULT$ = DOC$: CHK$ = ".": LOCDOT = INSTR(DOC$, CHK$): FAULT$ = LEFT$(DOC$, LOCDOT - 1)
4780 GOSUB 10240
4785 IF LEN(NFAULT$) > 8 THEN LOCATE 20, 10: INPUT "THE FILENAME IS TOO LONG.  PRESS ENTER TO CONTINUE  ", ANS$: GOTO 4760
4790 DOC$ = NFAULT$ + ".FM5": XIST = 0: GOSUB 4992
4791 IF OU$ = "LPT1:" THEN GOTO 4792 ELSE OU$ = DRIVE$ + NFAULT$ + ".PRN"

CHK$ = ".": LOCDOT = INSTR(DOC$, CHK$)
4792 FOR AA% = 1 TO COUNT%
4794 IF LEFT$(DOC$, LOCDOT - 1) = LEFT$(FileName$(AA%), LOCDOT - 1) THEN XIST = 1
4795 NEXT AA%
4796 IF XIST = 1 THEN LOCATE 20, 10: INPUT "THE FILE EXISTS.  DO YOU WANT TO REPLACE IT? Y/[N]  ", ANS$ ELSE GOTO 4800
4797 IF ANS$ <> "Y" AND ANS$ <> "y" THEN GOTO 4760
4800 QN1$ = "ENTER THE DESCRIPTIVE CASE IDENTIFICATION TITLE USED AS THE CASE IDENTIFIER": QN2$ = "(INPUT A NAME SUCH AS-> GAS FURNACE/15 KW/EXTERIOR FLUE/OCT 85)": FAULT$ = TITLE$: TFLAG = 1: TLEN = 30: GOSUB 10240
4810 TITLE$ = NFAULT$
4820 LOCATE 20, 10: COLOR 19, 0: PRINT "SAVING FILE TO "; DOC$
4830 OPEN INDRIVE$ + DOC$ FOR OUTPUT AS #2
4840 FOR AA% = 1 TO 19
4850 WRITE #2, ABS(HT(AA%)), AR(AA%), TN(AA%)
4860 NEXT AA%
4870 WRITE #2, NE%, NELBOWS, NFPSEGS%, TFPLN
4880 FOR FPSEG% = 1 TO NFPSEGS%: WRITE #2, RISE(FPSEG%), FPLN(FPSEG%): NEXT FPSEG%
4890 FOR AA% = 2 TO 4: FOR BB% = 1 TO NE%: WRITE #2, DI2(AA%, BB%), HC(AA%, BB%): NEXT BB%: NEXT AA%
4900 FOR AA% = 1 TO NE%: WRITE #2, ELTL(AA%), ELTS(AA%), ELTO(AA%), DENL(AA%), DENS(AA%), DENO(AA%), THCL(AA%), THCS(AA%), THCO(AA%): NEXT AA%
4910 FOR AA% = 1 TO 4: FOR BB% = 1 TO NE%: WRITE #2, TI(AA%, BB%): NEXT BB%: NEXT AA%
4920 WRITE #2, APRD, FICV, TCF2, F2, F1, SSEFF, TSSGE, CHIMT$, CHBOT, XPT
4930 WRITE #2, LNPP, LHC, C, N, T1, T9, VWIND, T6F, TMF, T7F, SCS, SEC, Z2, FS, AUFF, ST, PRFF$, PRCOND$, PRREG$, TITLE$, MOHE, HCHE, M2CP, QF, FP, VWINDH, VWINDV, FT$, SCSFLAG%
4940 WRITE #2, FPDI2(2), FPDI2(3), FPDI2(4), FPHC(2), FPHC(3), FPHC(4), FPELTL, FPELTS, FPELTO, FPDENL, FPDENS, FPDENO, FPTHCL, FPTHCS, FPTHCO
4950 WRITE #2, CHDI2(2), CHDI2(3), CHDI2(4), CHHC(2), CHHC(3), CHHC(4), CHELTL, CHELTS, CHELTO, CHDENL, CHDENS, CHDENO, CHTHCL, CHTHCS, CHTHCO
4955 WRITE #2, EXAIR, ARINT, VCLINT, NELINT, LEAKDIST, ICHTYPE%
4956 WRITE #2, DHWC, DHWSBC, DHWEF, DHWAR, DHWFPLE, DHWFPH, DHWNEL, DHWTYPE$, DHWFPN, DHWO$, FDAMP$, ARDAMP, FCAPL, DAMPACT$, DAMPTOP, DAMPTCL
4957 WRITE #2, TMONOFF, HVOL, HTC, HMASS$, MDI$, P$, GD$
4958 WRITE #2, NDHWFP%, TDHW, PHC, THETAW, PTC, VWINDT, FL1%, FL2%, TMP1%, TMP2%, TMP3%, TMP4%, P1%, P2%, P3%, P4%, FR1%, FR2%, FR3%, FR4%
4959 FOR AA% = 1 TO NDHWFP%
4960 FOR J% = 1 TO 5
4962 WRITE #2, TIDHW(J%, AA%)
4964 NEXT J%: NEXT AA%
4965 WRITE #2, OU$
4966 CLOSE #2
4980 COLOR 7
4990 GOTO 4390
4992 FOR AA% = 1 TO LEN(DOC$)
4993 CHA = ASC(MID$(DOC$, AA%, 1))
4994 IF CHA > 96 AND CHA < 127 THEN MID$(DOC$, AA%, 1) = CHR$(CHA - 32)
4995 NEXT
4996 RETURN
5000 REM: CHANGE FILE DATA ROUTINE
5006 IF FT$ = "G" THEN IF XPT < (CHBOT - 1) THEN FCTYPE = 3 ELSE FCTYPE = 4
5007 IF FT$ = "O" OR FT$ = "B" THEN IF XPT < (CHBOT - 1) THEN FCTYPE = 1 ELSE FCTYPE = 2
5010 CLS : PRINT : PRINT : COLOR 15, 0: PRINT "FILE CHANGE MENU": PRINT : COLOR 7
5020 PRINT TAB(5); "1-FUEL TYPE / FLUE LOCATION / VERTICAL DIMENSIONS"
5025 PRINT TAB(5); "2-FURNACE SPECIFICATIONS"
5030 PRINT TAB(5); "3-FLUE PIPE / VENT CONNECTOR  SPECIFICATIONS"
5040 PRINT TAB(5); "4-CHIMNEY CHARACTERISTICS"
5050 PRINT TAB(5); "5-ENVELOPE CHARACTERISTICS / AMBIENT & INITIAL CONDITIONS"
5080 PRINT TAB(5); "6-ENVELOPE LEAK & FRESH AIR INTAKE LOCATIONS"
5085 PRINT TAB(5); "7-DOMESTIC HOT WATER HEATER SPECIFICATIONS"
5087 PRINT TAB(5); "8-FLUE DAMPER AND FLUE CAP SPECIFICATIONS"
5090 PRINT TAB(5); "9-OPTIONAL SPECS:  THERMOSTAT, DRAFT INDUCER"
5100 PRINT TAB(4); "10-RETURN TO MAIN MENU"
5110 FOR AA% = 1 TO 10: LOCATE 4 + AA%, 2: PRINT CHM$(AA%): NEXT AA%
5120 LOCATE 23, 5: PRINT "(An * marks items that have been changed since the file was loaded)": LOCATE 14, 10
5130 PRINT : COLOR 15, 0: PRINT : INPUT "YOUR SELECTION  (NUMBER FROM 1 TO 10) --> "; SS$: COLOR 7
5140 SS = VAL(SS$)
5150 IF SS < 1 OR SS > 10 THEN GOTO 5010
5160 ON SS GOTO 5930, 6190, 6500, 7830, 8420, 11000, 14000, 15000, 12000, 4390
5170 REM: CHAIN INTO FLUESIM AND RUN PROGRAM
5174  HDR$ = "RUN IDENTIFIER": QN1$ = "ENTER THE RUN IDENTIFICATION": QN2$ = "(Omit the FUEL TYPE and DATE as these are automatically printed)": FAULT$ = TITLE$: TFLAG = 1: TLEN = 30: GOSUB 10240
5176  TITLE$ = NFAULT$
5180 PRFLAG% = 1
5185 PRFLAG2% = 0
5190 COLOR 19: LOCATE 20, 50: PRINT "***   Please Standby ***": COLOR 7
5200 CHAIN "FLUESIM5"
5210 REM: CONTINUE PROGRAM RUN
5220 IF PRFLAG% = 0 THEN LOCATE 20, 5: PRINT "SORRY - YOU MUST EXECUTE A RUN FIRST BEFORE YOU CAN EXTEND IT.": GOSUB 10690: GOTO 4390
5222 CFLAG% = 0'CHECK FOR CONTINUE AFTER EDITING INPUT DATA
5224 FOR I% = 1 TO 10
5225 IF CHM$(I%) = "*" THEN CFLAG% = 1
5226 NEXT I%
5227 IF CFLAG% = 1 THEN BEEP: LOCATE 20, 5: PRINT "SORRY - You cannot Continue after changing the input data.": LOCATE 21, 5: PRINT "Select the RUN option.": GOSUB 10695: GOTO 4390
5230 CLS : HDR$ = "EXTENDED RUN OPTION": QN1$ = "INPUT EXTENDED END LIMIT FOR SIMULATION RUN": QN2$ = "(INPUT IN Seconds)": FAULT = ST: GOSUB 10240: IF NFAULT < SCS OR NFAULT > 1000000! THEN GOTO 5230
5240 ST = NFAULT
5250 CLS : LOCATE 20, 40: COLOR 19: PRINT "Please Standby": COLOR 7
5260 PRFLAG2% = 5678
5270 CHAIN "FLUESIM5"
5280 REM: PRINT OUT OF SET UP DATA
5860 GOTO 4390
5920 CLS : PRINT : PRINT : PRINT "PROGRAM COMPLETED": END
5930 REM: CHOICE OF FUEL TYPE / FLUE LOCATION & SPECS OF VERTICAL DIMENSIONS
5940 CHM$(1) = "*"
5944 SCRTL$ = "OGFIEC"
5946 NF% = 1
5948 FOR I% = 1 TO NF%: VAR(I%) = -9997: NEXT
5950 '
5951 IF FT$ = "G" THEN IF XPT < (CHBOT - 1) THEN VAR(1) = 3 ELSE VAR(1) = 4
5952 IF FT$ = "O" OR FT$ = "B" THEN IF XPT < (CHBOT - 1) THEN VAR(1) = 1 ELSE VAR(1) = 2
5954 GOSUB 2000
5956 FCTYPE = VAL(SI.DATA$(1))
5960 IF FCTYPE = 2 * INT(FCTYPE / 2) THEN CHIMT$ = "E" ELSE CHIMT$ = "I"
6030 '

     IF FTP$(FCTYPE) = "O" THEN
	CLS : LOCATE 10, 1
	PRINT "IS THE HEATING APPLIANCE:"
	PRINT
	PRINT "         1. A FORCED AIR FURNACE?"
	PRINT "         2. A BOILER?"
	PRINT
	PRINT "         YOUR CHOICE --> (1 or 2)"
	LOCATE 15, 35: IF FT$ = "B" THEN PRINT "2";  ELSE PRINT "1";
	AN$ = "": WHILE AN$ = "": AN$ = INKEY$: WEND
	IF ASC(AN$) = 13 THEN GOTO 6050
	LOCATE 15, 35: PRINT " "; AN$;
	WHILE INKEY$ = "": WEND
	IF VAL(AN$) < 1 OR VAL(AN$) > 2 THEN GOTO 6030
	IF VAL(AN$) = 1 THEN FT$ = "O" ELSE FT$ = "B"
     ELSE FT$ = "G"
     END IF

6050 SCRTL$ = SCRFT$(FCTYPE)
6052 NF% = 7
6053 TROB1 = CHBOT: TROB2 = HT(4)
6056 '
6058 VAR(1) = LHC
6062 VAR(5) = HT(14)
6064 VAR(4) = HT(17)
6066 VAR(3) = HT(6)
6068 VAR(2) = CHBOT
6070 VAR(6) = 2 * (HT(6) - HT(4))
6072 VAR(7) = TFPLN
6075 IF FT$ = "G" THEN VAR(6) = HT(14): VAR(3) = HT(4): VAR(5) = HT(6)
6080 GOSUB 2000
6158 LHC = VAL(SI.DATA$(1))
6162 HT(14) = VAL(SI.DATA$(5))
6164 HT(17) = VAL(SI.DATA$(4))
6166 HT(6) = VAL(SI.DATA$(3))
6168 CHBOT = VAL(SI.DATA$(2))
6170 HT(4) = HT(6) - VAL(SI.DATA$(6)) / 2
6172 TFPLN = VAL(SI.DATA$(7))
6174 IF FT$ = "G" THEN HT(14) = VAL(SI.DATA$(6)): HT(4) = VAL(SI.DATA$(3)): HT(6) = VAL(SI.DATA$(5))
6175 IF TROB1 <> CHBOT OR TROB2 <> HT(4) THEN FPFLAG% = 0
6181 IF FCTYPE = 1 OR FCTYPE = 3 THEN XPT = LHC ELSE XPT = CHBOT
6182 HT(15) = HT(14): HT(16) = HT(14)
6183 HT(8) = LNPP: HT(9) = LNPP
6184 HT(18) = HT(17)
6186 HT(10) = HT(6): HT(11) = HT(6): HT(12) = HT(6): HT(13) = HT(6): HT(19) = HT(6)
6188 HT(5) = HT(4)
6189 GOTO 5010
6190 REM      FURNACE SPECIFICATIONS
6191 CHM$(2) = "*"
6192 SCRTL$ = SCRFT1$(FCTYPE)
6194 IF FT$ = "O" OR FT$ = "B" THEN NF% = 12 ELSE NF% = 10
6196 FOR I% = 1 TO NF%: VAR(I%) = -9997: NEXT
6198 VAR(1) = AR(15)
6200 VAR(2) = AR(18)
6202 VAR(3) = AR(11)
6204 VAR(4) = APRD
6206 VAR(5) = FICV
6208 VAR(6) = MOHE
6210 VAR(7) = HCHE
6211 VAR(8) = F2
6212 VAR(9) = F1
6213 VAR(10) = SSEFF * 100
6214 VAR(11) = TSSGE
     IF FT$ = "O" OR FT$ = "B" THEN
	FurnaceFlow = (F2 * (1 - SSEFF - .055) / ((TSSGE - T9) * 1035))
	EXAIR = ((FurnaceFlow / (353.6 / 273.15)) - ((286 * F2 * 3.413) / 3.6E+09)) / (2.625 * F2 * 3.413 / 3.6E+09)
     END IF
6215 VAR(12) = EXAIR
6220 IF FT$ = "O" OR FT$ = "B" THEN GOTO 6300
6230 FOR I% = 4 TO 10
6240 VAR(I%) = VAR(I% + 1)
6250 NEXT
6300 GOSUB 2000
6305 IF FT$ = "O" OR FT$ = "B" THEN GOTO 6350
6310 FOR I% = 10 TO 4 STEP -1
6315 SI.DATA$(I% + 1) = SI.DATA$(I%)
6320 NEXT
6350 AR(15) = VAL(SI.DATA$(1))
6352 AR(18) = VAL(SI.DATA$(2))
6354 AR(11) = VAL(SI.DATA$(3))
6358 FICV = VAL(SI.DATA$(5))
6360 MOHE = VAL(SI.DATA$(6))
6362 HCHE = VAL(SI.DATA$(7))
6364 F2 = VAL(SI.DATA$(8))
6366 F1 = VAL(SI.DATA$(9))
6368 SSEFF = VAL(SI.DATA$(10)) / 100
6370 TSSGE = VAL(SI.DATA$(11))
6371 IF FT$ = "G" THEN GOTO 6374
6372 EXAIR = VAL(SI.DATA$(12))
6373 APRD = VAL(SI.DATA$(4))
6374 M2CP = MOHE * HCHE
     IF FT$ = "O" OR FT$ = "B" THEN
	FurnaceFlow = (F2 * (1 - SSEFF - .055) / ((TSSGE - T9) * 1035))
	EXAIR = ((FurnaceFlow / (353.6 / 273.15)) - ((286 * F2 * 3.413) / 3.6E+09)) / (2.625 * F2 * 3.413 / 3.6E+09)
     END IF
6376 GOTO 5010
6500 REM: INPUT OF FLUE PIPE DIMENSIONS
6505 REM DEFAULT VALUES FLAG. IF FPFLAG%=0 A DEFAULT VALUE HAS CHANGED.
6510 STRTOVR$ = "N"
6515 REM ESTABLISH FURNACE/FLUEPIPE CONNECTION AS REFERENCE HEIGHT
6520 REM CALCULATE MAXIMUM RISE USING PREVIOUS INPUTS
6525 REM
6530 RISEMAX = ABS(CHBOT - HT(5)): RISET = 0: FPLNT = 0
6535 CHM$(3) = "*"
6540 REM
6545 REM:NUMBER OF STRAIGHT SEGMENTS IN FLUE PIPE
6550 REM
6555 HDR$ = "FLUE PIPE CHARACTERISITCS"
6560 QN1$ = "TOTAL NUMBER OF STRAIGHT SECTIONS FROM TOP OF DILUTION DEVICE TO CHIMNEY BOTTOM": QN2$ = "INPUT NUMBER OF SEGMENTS"
6565 FAULT = NFPSEGS%: GOSUB 10240: IF NFAULT < 1 OR NFAULT > 5 THEN GOSUB 10690: GOTO 6565
6570 NFPSEGS% = NFAULT
6575 IF NFAULT <> FAULT THEN FPFLAG% = 0: REM DEFAULT INPUT IS CHANGED
6580 REM
6585 REM INPUT TOTAL LENGTH OF ALL SECTIONS OF THE FLUEPIPE
6590 REM
6595 'QN1$="TOTAL AXIAL LENGTH OF ALL SECTIONS FROM TOP OF DILUTION DEVICE TO CHIMNEY BOTTOM":QN2$="(INPUT IN m)"
6600 'FAULT=TFPLN:GOSUB 10240:IF NFAULT< 0 OR NFAULT> 5 THEN GOSUB 10690:GOTO 6600
6605 FPLNMAX = TFPLN: REM TFPLN = NFAULT
6610 'IF NFAULT<>FAULT THEN FPFLAG% = 0:REM DEFAULT INPUT IS CHANGED
6625 REM
6630 REM ENTER NUMBER OF ELBOWS IN FLUEPIPE CONFIGURATION
6635 REM
6640 QN1$ = "HOW MANY  45 deg. ELBOWS IN THE FLUE PIPE OR VENT CONNECTOR"
6645 QN2$ = "(ENTER 2 FOR EACH 90 deg. ELBOW.  ADD 2.5 FOR A TEE SECTION)": FAULT = NELBOWS: GOSUB 10240: IF NFAULT < 0 OR NFAULT > 10 THEN GOSUB 10690: GOTO 6645
6650 NELBOWS = NFAULT
6655 NEO% = NE%: NE% = NFPSEGS% + 8
6660 REM
6665 REM INSTRUCTIONS AND EXPLANATIONS TO CONSTRUCT FLUEPIPE
6670 REM
6675 'CLS:PRINT HDR$:PRINT:PRINT "YOU WILL BE ASKED TO ENTER THE RISE AND LENGTH OF EACH SECTION OF YOUR FLUE PIPE"
6680 'PRINT:PRINT "IF YOU DO NOT HAVE SUFFICIENT INFORMATION TO SATISFY A CERTAIN INPUT I WILL GIVEYOU A DEFAULT VALUE YOU CAN USE BASED ON PREVIOUS INFORMATION YOU HAVE INPUTTED":PRINT:PRINT:PRINT"                           HIT ANY KEY TO CONTINUE"
6685 'KB$=INKEY$:IF KB$="" THEN 40240
6690 REM
6695 REM CONSTRUCTION/DEFINITION OF FLUEPIPE CONFIGURATION
6700 REM
6705 FOR FPSEG% = 1 TO NFPSEGS%
6710 REM
6715 REM CALCULATE/DEFINE RISE OF PARTICULAR SECTION
6720 REM
6725 ROR$ = "RISE"
6730 QN1$ = "SECTION ": FPSEG$ = STR$(FPSEG%): QN1$ = QN1$ + FPSEG$: QN2$ = "INPUT THE " + ROR$ + " OF THIS SECTION(in m)"
6735 REM
6740 REM IF A PREVIOUS DEFAULT HAS BEEN CHANGED GENERATE NEW DEFAULTS. IF NO PREVIOUS INPUTS HAVE BEEN CHANGED USE DEFAULT VALUES LOADED FROM DEFAULT FILE.
6745 REM
6750 IF FPFLAG% = 0 THEN GOTO 6775 ELSE FAULT = RISE(FPSEG%): GOTO 6780
6755 REM:IF FPSEG% = 1 THEN FAULT=.1:GOTO 40335:REM:FIX THE BOTTOM OF THE FLUE PIPE
6760 REM
6765 REM GENERATE NEW DEFAULT RISE FOR NEXT SECTION.DEFAULT RISE IS REMAINING RISE DIVIDED BY REMAINING NUMBER OF ELBOWS.CHECK TO MAKE SURE INPUT DOES NOT EXCEED REMAINING RISE.CHECK LAST SECTION REACHES THE CHIMNEY BOTTOM. ALLOW A 10cm ERROR
6770 REM
6775 FAULT = ABS((RISEMAX - RISET) / ((NFPSEGS% - FPSEG% + 1)))
6780 GOSUB 10240: IF NFAULT < 0 THEN GOSUB 10690: GOTO 6780
6785 IF (NFAULT - (RISEMAX - RISET)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6780
6790 IF FPSEG% = NFPSEGS% AND ABS(RISEMAX - (RISET + NFAULT)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6780
6795 RISE(FPSEG%) = NFAULT: IF NFAULT <> FAULT THEN FPFLAG% = 0: REM DEFAULT INPUT HAS BEEN CHANGED
6800 REM:IF NFAULT<>FAULT THEN FPFLAG%=0:REM DEFAULT INPUT HAS BEEN CHANGED
6805 RISET = RISET + RISE(FPSEG%): REM KEEP CUMULATIVE TRACK OF RISES.
6810 REM
6815 REM CALCULATE/DEFINE LENGTH OF PARTICULAR SECTION
6820 REM IF ANY PREVIOUS INPUTS HAVE NOT BEEN CHANGED THEN USE DEFAULTS LOADED FROM DEFAULT FILE ELSE GENERATE NEW DEFAULTS. MAKE SURE THE INPUT IS NOT GREATER THAN REMAINING LENGTH. MAKE SURE THE LAST SECTION IS WITHIN 10cm OF THE CHIMNEY BOTTOM.
6825 REM
6830 REM
6835 ROR$ = "LENGTH": QN1$ = QN1$: QN2$ = "INPUT THE " + ROR$ + " OF THIS SECTION(in m)"
6840 IF FPFLAG% = 0 THEN GOTO 6845 ELSE FAULT = FPLN(FPSEG%): GOTO 6850
6845 FAULT = ((FPLNMAX - FPLNT) / ((NFPSEGS% - FPSEG%) + 1))
6850 GOSUB 10240: IF NFAULT < 0 THEN GOSUB 10690: GOTO 6860
6855 REM:IF FPSEG% = 1 THEN FAULT=RISE(FPSEG%):GOTO 40405
6860 IF (NFAULT - (FPLNMAX - FPLNT)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6850
6865 IF FPSEG% = NFPSEGS% AND ABS(FPLNMAX - (FPLNT + NFAULT)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6850
6870 IF ABS(RISET - RISEMAX) < .1 AND ABS((FPLNT + NFAULT) - FPLNMAX) < .1 AND FPSEG% < NFPSEGS% THEN GOSUB 10725: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6850: REM:IF FLUEPIPE FITS AND ELBOWS STILL NOT USED UP SIGNAL ERROR
6875 FPLN(FPSEG%) = NFAULT: IF NFAULT <> FAULT THEN FPFLAG% = 0
6880 FPLNT = FPLNT + FPLN(FPSEG%): REM KEEP A CUMULATIVE TRACK OF LENGTHS
6885 NEXT FPSEG%
6886 FPFLAG% = 1
7270 REM:IF FPSEG%>1 AND FPFLAG%<>1 THEN FPDI2(2,FPSEG%)=FPDI2(2,FPSEG%-1)
7400 SCRTL$ = "FPIPE1"
7405 NF% = 16
7410 VAR(1) = AR(5)
7420 VAR(2) = FPDI2(2)
7430 VAR(3) = FPDI2(3)
7432 VAR(4) = FPDI2(4)
7435 VAR(5) = FPELTL
7440 VAR(6) = FPELTS
7445 VAR(7) = FPELTO
7450 VAR(8) = FPDENL
7455 VAR(9) = FPDENS
7460 VAR(10) = FPDENO
7465 VAR(11) = FPHC(2)
7467 VAR(12) = FPHC(3)
7468 VAR(13) = FPHC(4)
7470 VAR(14) = FPTHCL
7472 VAR(15) = FPTHCS
7473 VAR(16) = FPTHCO
7475 GOSUB 2000
7480 AR(5) = VAL(SI.DATA$(1))
7485 FPDI2(2) = VAL(SI.DATA$(2))
7490 FPDI2(3) = VAL(SI.DATA$(3))
7495 FPDI2(4) = VAL(SI.DATA$(4))
7500 FPELTL = VAL(SI.DATA$(5))
7505 FPELTS = VAL(SI.DATA$(6))
7510 FPELTO = VAL(SI.DATA$(7))
7515 FPDENL = VAL(SI.DATA$(8))
7520 FPDENS = VAL(SI.DATA$(9))
7525 FPDENO = VAL(SI.DATA$(10))
7530 FPHC(2) = VAL(SI.DATA$(11))
7531 FPHC(3) = VAL(SI.DATA$(12))
7532 FPHC(4) = VAL(SI.DATA$(13))
7535 FPTHCL = VAL(SI.DATA$(14))
7540 FPTHCS = VAL(SI.DATA$(15))
7545 FPTHCO = VAL(SI.DATA$(16))
7550 AR(4) = AR(5)
7720 FOR ZZ% = 1 TO NFPSEGS%
7730 DI2(2, ZZ%) = FPDI2(2): HC(2, ZZ%) = FPHC(2)
7740 DI2(3, ZZ%) = FPDI2(3): HC(3, ZZ%) = FPHC(3)
7750 DI2(4, ZZ%) = FPDI2(4): HC(4, ZZ%) = FPHC(4)
7760 ELTL(ZZ%) = FPELTL: ELTS(ZZ%) = FPELTS: ELTO(ZZ%) = FPELTO
7770 DENL(ZZ%) = FPDENL: DENS(ZZ%) = FPDENS: DENO(ZZ%) = FPDENO
7780 THCL(ZZ%) = FPTHCL: THCS(ZZ%) = FPTHCS: THCO(ZZ%) = FPTHCO
7790 NEXT ZZ%
7800 IF NE% <> NEO% THEN GOTO 8310
7820 GOTO 5010
7830 REM: INPUT OF CHIMNEY CHARACTERISTICS
7840 SCSFLAG% = 0
7850 CHM$(4) = "*"
7855 SCRTL$ = "CHIM#1"
7860 NF% = 1: VAR(1) = ICHTYPE%
7865 GOSUB 2000
7866 IF ICHTYPE% = VAL(SI.DATA$(1)) THEN GOTO 7900
7867 CLS : LOCATE 6, 1: PRINT "The graphic on the following screen has been changed"
7868 PRINT "to show a(n) "; CTYP$(VAL(SI.DATA$(1))); " chimney"
7869 LOCATE 9, 1: PRINT "However the numerical entries have NOT been changed -  ": LOCATE 11, 1: PRINT "they are the values in the file you loaded."
7870 LOCATE 13, 1: PRINT "You can change them now or start again with a file ";
7871 LOCATE 15, 1: PRINT "which includes a(n) "; CTYP$(VAL(SI.DATA$(1))); " chimney"
7872 LOCATE 18, 1: INPUT "Your choice: Change or Start again - [C]/S?  ", ANS$
7874 IF ANS$ = "S" OR ANS$ = "s" THEN GOTO 4390
7880 ICHTYPE% = VAL(SI.DATA$(1))
7900 SCRTL$ = SCRCT$(ICHTYPE%)
7905 NF% = 16
7915 VAR(1) = AR(2)
7920 VAR(2) = CHDI2(2)
7925 VAR(3) = CHDI2(3)
7930 VAR(4) = CHDI2(4)
7935 VAR(5) = CHELTL
7940 VAR(6) = CHELTS
7945 VAR(7) = CHELTO
7950 VAR(8) = CHDENL
7955 VAR(9) = CHDENS
7960 VAR(10) = CHDENO
7965 VAR(11) = CHHC(2)
7967 VAR(12) = CHHC(3)
7968 VAR(13) = CHHC(4)
7970 VAR(14) = CHTHCL
7972 VAR(15) = CHTHCS
7974 VAR(16) = CHTHCO
7975 GOSUB 2000
7980 AR(2) = VAL(SI.DATA$(1))
7985 CHDI2(2) = VAL(SI.DATA$(2))
7990 CHDI2(3) = VAL(SI.DATA$(3))
7995 CHDI2(4) = VAL(SI.DATA$(4))
8000 CHELTL = VAL(SI.DATA$(5))
8005 CHELTS = VAL(SI.DATA$(6))
8010 CHELTO = VAL(SI.DATA$(7))
8015 CHDENL = VAL(SI.DATA$(8))
8020 CHDENS = VAL(SI.DATA$(9))
8025 CHDENO = VAL(SI.DATA$(10))
8030 CHHC(2) = VAL(SI.DATA$(11))
8031 CHHC(3) = VAL(SI.DATA$(12))
8032 CHHC(4) = VAL(SI.DATA$(13))
8035 CHTHCL = VAL(SI.DATA$(14))
8040 CHTHCS = VAL(SI.DATA$(15))
8045 CHTHCO = VAL(SI.DATA$(16))
8110 AR(3) = AR(2)
8280 REM:  PUT REFERENCE VARIABLES INTO INTO EACH OF THE CHIMNEY ELEMENTS
8290 REM:DI2(1,1)=DI2(2):DI2(1,2)=DI2(2,2)
8300 REM:DI2(2,1)=DI2(2,2):DI2(3,1)=DI2(3,2):DI2(4,1)=DI2(4,2)
8310 FOR ZZ% = NFPSEGS% + 1 TO NE%
8320 DI2(2, ZZ%) = CHDI2(2): HC(2, ZZ%) = CHHC(2)
8330 DI2(3, ZZ%) = CHDI2(3): HC(3, ZZ%) = CHHC(3)
8340 DI2(4, ZZ%) = CHDI2(4): HC(4, ZZ%) = CHHC(4)
8350 ELTL(ZZ%) = CHELTL: ELTS(ZZ%) = CHELTS: ELTO(ZZ%) = CHELTO
8360 DENL(ZZ%) = CHDENL: DENS(ZZ%) = CHDENS: DENO(ZZ%) = CHDENO
8370 THCL(ZZ%) = CHTHCL: THCS(ZZ%) = CHTHCS: THCO(ZZ%) = CHTHCO
8380 NEXT ZZ%
8390 IF NE% <> NEO% THEN GOTO 8860
8400 REM: RETURN FROM FLUE CHANGES ROUTINE
8410 GOTO 5010
8420 REM: ENVELOPE CHARACTERISTICS / AMBIENT AND INITIAL CONDITIONS
8430 CHM$(5) = "*"
8590 SCSFLAG% = 0
8600 SCRTL$ = "GENRL1"
8610 NF% = 14
8620 VAR(1) = 1.157 * SQR(353.6 / (273.15 + T1)) * C * 10 ^ (N - .5)
8625 VAR(2) = N
8630 VAR(3) = QF
8635 VAR(4) = FP
8640 VAR(5) = T1
8645 VAR(6) = T9
8650 VAR(7) = VWINDH
8655 VAR(8) = VWINDV
8657 VAR(9) = TI(1, 6)
8660 VAR(10) = TI(2, 6)
8665 VAR(11) = TI(3, 6)
8667 VAR(12) = TI(4, 6)
8668 VAR(13) = TMF
8670 VAR(14) = T7F
8675 GOSUB 2000
8680 ELADUM = VAL(SI.DATA$(1))
8685 N = VAL(SI.DATA$(2))
8690 QF = VAL(SI.DATA$(3))
8695 FP = VAL(SI.DATA$(4))
8700 T1 = VAL(SI.DATA$(5))
8703 C = ELADUM / (1.157 * SQR(353.6 / (273.15 + T1)) * 10 ^ (N - .5))
8705 T9 = VAL(SI.DATA$(6))
8710 VWINDH = VAL(SI.DATA$(7))
8715 VWINDV = VAL(SI.DATA$(8))
8720 TI(1, 6) = VAL(SI.DATA$(9))
8725 TI(2, 6) = VAL(SI.DATA$(10))
8730 TI(3, 6) = VAL(SI.DATA$(11))
8731 TI(4, 6) = VAL(SI.DATA$(12))
8732 TMF = VAL(SI.DATA$(13))
8735 T7F = VAL(SI.DATA$(14))
8740 VWINDT = SQR(VWINDH ^ 2 + VWINDV ^ 2)
8742 IF VWINDH = 0! AND VWINDV < 0! THEN THETAW = -90!: GOTO 8860
8744 IF VWINDH = 0! AND VWINDV > 0! THEN THETAW = 90!: GOTO 8860
8750 IF VWINDH = 0! AND VWINDV = 0! THEN THETAW = 0! ELSE THETAW = 180! * ATN(VWINDV / VWINDH) / 3.141593
8860 FOR AA% = 2 TO NE%: TI(1, AA%) = TI(1, 6): TI(2, AA%) = TI(2, 6): TI(3, AA%) = TI(3, 6): TI(4, AA%) = TI(4, 6): NEXT AA%
8870 T6F = T7F
8880 TN(1) = T1: TN(2) = TI(1, 1): TN(3) = TN(2): TN(4) = TN(2): TN(5) = TN(2): TN(6) = (T6F + T9) / 2: TN(7) = T1: TN(8) = T1: TN(9) = T9: TN(10) = T9: TN(11) = T9: TN(12) = TN(6): TN(13) = T9: TN(14) = T9: TN(15) = T9: TN(16) = T6F: TN(17) = T6F: _
               TN(18) = T6F: TN(19) = TN(6)
8890 GOTO 5010
8900 REM: RUN TIME CONTROLS
8915 SCRTL$ = "GENRL2"
8916 NF% = 6
8920 VAR(1) = SCS
8925 VAR(2) = SEC
8930 VAR(3) = FS
8935 VAR(4) = AUFF
8940 VAR(5) = ST
8950 VAR(6) = Z2
8975 GOSUB 2000
8980 SCS = VAL(SI.DATA$(1))
8985 SEC = VAL(SI.DATA$(2))
8990 FS = VAL(SI.DATA$(3))
8995 AUFF = VAL(SI.DATA$(4))
8997 ST = VAL(SI.DATA$(5))
8999 Z2 = VAL(SI.DATA$(6))
9020 GOTO 4390
9030 REM: OUTPUT FORMAT MENU
9050 CLS : SCREEN 0: KEY OFF
9060 TLEN = 1: TFLAG = 1: QN1$ = "DO YOU WANT YOUR OUTPUTS ON A GRAPH (G) OR IN TABLES (T)": HDR$ = "PRINT CONTROLS": QN2$ = "(ENTER EITHER  G  OR  T)": FAULT$ = GD$: GOSUB 10240
9070 GD$ = NFAULT$
9080 IF GD$ = "G" OR GD$ = "g" THEN GD$ = "G": GOTO 9170
9090 IF GD$ = "T" OR GD$ = "t" THEN GD$ = "T": GOTO 9100
9095 GOSUB 10690: GOTO 9060
9100 TLEN = 1: TFLAG = 1: QN1$ = "Do you want a DETAILED summary or a PRESSURE PARAMETER summary ": HDR$ = "PRINT CONTROLS": QN2$ = "(ENTER EITHER  D  OR  P)": FAULT$ = P$: GOSUB 10240
9110 P$ = NFAULT$
9112 IF P$ = "p" THEN P$ = "P"
9114 IF P$ = "d" THEN P$ = "D"
9115 IF P$ = "P" OR P$ = "D" THEN GOTO 9120 ELSE GOSUB 10690: GOTO 9100
9120 QN1$ = "INTERVAL BETWEEN PRINTER OUTPUTS": QN2$ = "(In seconds between print lines; e.g. 20 seconds)": FAULT = Z2: GOSUB 10240: IF NFAULT < 0 OR NFAULT > 1000 THEN GOSUB 10690: GOTO 9120
9130 Z2 = NFAULT
9135 IF IOUT = 1 THEN FAULT$ = "P" ELSE FAULT$ = "D"
9137 IF OU$ = "LPT1:" THEN FAULT$ = "P"
9140 TFLAG = 1: TLEN = 1: QN1$ = "DO YOU WANT THE OUTPUTS ON THE PRINTER (P)  OR  ON DISK  (D)": HDR$ = "PRINT CONTROLS": QN2$ = "(ENTER EITHER  P  OR  D)": GOSUB 10240
9145 IF NFAULT$ = "D" OR NFAULT$ = "d" OR NFAULT$ = "P" OR NFAULT$ = "p" THEN GOTO 9146 ELSE GOSUB 10690: GOTO 9140
9146 FAULT$ = DOC$: CHK$ = ".": LOCDOT = INSTR(DOC$, CHK$): FAULT$ = DRIVE$ + LEFT$(DOC$, LOCDOT - 1)
9148 IF NFAULT$ = "P" OR NFAULT$ = "p" THEN OU$ = "LPT1:"
9150 IF NFAULT$ = "D" OR NFAULT$ = "d" THEN TFLAG = 1: TLEN = 1: QN1$ = "ENTER THE NAME OF THE OUTPUT DISK FILE": QN2$ = "(the default drive and extension .PRN are added automatically)": GOSUB 10240: OU$ = NFAULT$ + ".PRN"
9160 FL1% = 0: GOTO 4390
9170 IF IGRAPH = 1 THEN 9174
9171 CLS : LOCATE 5, 1: PRINT "YOUR SYSTEM APPARENTLY DOES NOT HAVE COMPATIBLE GRAPHICS CAPABILITY": PRINT "YOUR OUTPUTS WILL BE TABULAR INSTEAD"
9172 T = TIMER: WHILE TIMER < T + 5: WEND
9173 GD$ = "T": GOTO 9100
9174 FL1% = 1: CLS : SCREEN 0
9180 E$ = "DO YOU WISH TO PLOT:"
9190 G$ = "TEMPERATURE vs. TIME   (T)"
9200 H$ = "PRESSURE vs. TIME      (P)"
9210 I$ = "FLOW RATE vs. TIME     (F)"
9220 LOCATE 4, INT(70 - LEN(E$)) * .5: PRINT E$
9230 LOCATE 7, INT(70 - LEN(G$)) * .5: PRINT G$
9240 LOCATE 9, INT(70 - LEN(H$)) * .5: PRINT H$
9250 LOCATE 11, INT(70 - LEN(I$)) * .5: PRINT I$
9252 IF FL2% = 2 THEN FAULT$ = "F" ELSE IF FL2% = 1 THEN FAULT$ = "P" ELSE FAULT$ = "T"
9260 LOCATE 15, 20: PRINT "YOUR DEFAULT IS "; FAULT$; " ";
9265 LOCATE 17, 20: INPUT "T,P,F or ENTER(for default) "; ANS$
9267 IF ANS$ = "" THEN GOTO 9305
9270 IF ANS$ <> "T" AND ANS$ <> "P" AND ANS$ <> "F" AND ANS$ <> "t" AND ANS$ <> "p" AND ANS$ <> "f" THEN 9265
9280 IF ANS$ = "T" OR ANS$ = "t" THEN FL2% = 0
9290 IF ANS$ = "P" OR ANS$ = "p" THEN FL2% = 1
9300 IF ANS$ = "F" OR ANS$ = "f" THEN FL2% = 2
9305 ON FL2% GOTO 9660, 10030
9310 CLS
9320 TMTL$(1) = "YOU CAN PLOT  4  OF  8  TEMPERATURE VALUES vs. TIME"
9330 TMTL$(2) = "YOUR CHOICES ARE :"
9340 TMTL$(3) = "1 - FURNACE STACK GAS TEMP."
9350 TMTL$(4) = "2 - DILUTION MIXING TEMP."
9360 TMTL$(5) = "3 - MEAN FLUE GAS TEMP."
9370 TMTL$(6) = "4 - FLUE EXIT GAS TEMP."
9380 TMTL$(7) = "5 - MEAN FLUE LINER TEMP."
9390 TMTL$(8) = "6 - FURNACE HEAT-EXCHANGER TEMP."
9395 TMTL$(9) = "7 - ROOM TEMP. (if thermostat controlled)"
9397 TMTL$(10) = "8 - DHW FLUE GAS TEMP."
9400 TMTL$(11) = "YOUR DEFAULT VALUES ARE > "
9410 TMTL$(12) = "PRESS <ENTER> TO SELECT DEFAULT VALUES"
9420 TMTL$(13) = "OR C TO ENTER FOUR NEW OUTPUT VALUES"
9430 LOCATE 4, INT(70 - LEN(TMTL$(1))) * .5: PRINT TMTL$(1)
9440 LOCATE 6, INT(70 - LEN(TMTL$(2))) * .5: PRINT TMTL$(2)
9450 FOR X% = 1 TO 8
9460 LOCATE X% + 7, 20: PRINT TMTL$(X% + 2)
9470 NEXT X%
9475 LOCATE 17, INT(70 - LEN(TMTL$(11))) * .5: PRINT TMTL$(11); : PRINT USING " ##, ##, ##, and ##"; TMP1%, TMP2%, TMP3%, TMP4%
9480 FOR X% = 1 TO 2
9490 LOCATE 17 + X%, INT(70 - LEN(TMTL$(11 + X%))) * .5: PRINT TMTL$(11 + X%)
9500 NEXT X%
9510 LOCATE 21, 39: INPUT ANS$
9520 IF ANS$ = "" THEN GOTO 4390
9530 IF ANS$ = "C" OR ANS$ = "c" THEN 9550
9540 IF ANS$ <> "" OR ANS$ <> "C" OR ANS$ <> "c" THEN 9510
9550 FOR X% = 1 TO 7
9560 LOCATE 15 + X%, 1: PRINT "                                                                               "
9570 NEXT X%
9580 LOCATE 16, 15: INPUT "INPUT FOUR NEW VALUES (NUMBERS 1 TO 8)"; TMP1%, TMP2%, TMP3%, TMP4%
9590 IF TMP1% < 1 OR TMP1% > 8 THEN 9550
9600 IF TMP2% < 1 OR TMP2% > 8 THEN 9550
9610 IF TMP3% < 1 OR TMP3% > 8 THEN 9550
9620 IF TMP4% < 1 OR TMP4% > 8 THEN 9550
9630 GOTO 4390
9660 CLS
9670 PRTL$(1) = "YOU CAN PLOT  4  OF  13  PRESSURE VALUES vs. TIME"
9680 PRTL$(2) = "YOUR CHOICES ARE :"
9690 PRTL$(3) = " 1 - CHIM/HOUSE BUOYANCY"
9700 PRTL$(4) = " 2 - FLUE FRICTION LOSS"
9710 PRTL$(5) = " 3 - FURNACE BUOYANCY"
9720 PRTL$(6) = " 4 - FURNACE OUTLET LOSS"
9730 PRTL$(7) = " 5 - ENVELOPE LOSS"
9740 PRTL$(8) = " 6 - NET DRIVING PRESSURE"
9750 PRTL$(9) = " 7 - FURNACE INLET LOSS"
9760 PRTL$(10) = " 8 - NET FURNACE DRIVING PRESSURE"
9770 PRTL$(11) = " 9 - DILUTION PORT LOSS"
9780 PRTL$(12) = "10 - WIND EFFECT"
9785 PRTL$(13) = "11 - DRAFT INDUCER PRESSURE RISE"
9790 PRTL$(14) = "12 - DHW INDUCED"
9795 PRTL$(15) = "13 - DHW BUOYANCY"
9797 PRTL$(16) = "YOUR DEFAULT VALUES ARE> "
9800 PRTL$(17) = "PRESS <ENTER> TO SELECT DEFAULT VALUES"
9810 PRTL$(18) = "OR C TO ENTER FOUR NEW OUTPUT VALUES"
9820 LOCATE 2, INT(70 - LEN(PRTL$(1))) * .5: PRINT PRTL$(1)
9830 LOCATE 4, INT(70 - LEN(PRTL$(2))) * .5: PRINT PRTL$(2)
9840 FOR X% = 1 TO 13
9850 LOCATE 5 + X%, 20: PRINT PRTL$(X% + 2)
9860 NEXT X%
9865 LOCATE 20, INT(70 - LEN(PRTL$(16))) * .5: PRINT PRTL$(16); : PRINT USING " ##, ##, ##, and ##"; P1%, P2%, P3%, P4%
9870 FOR X% = 1 TO 2
9880 LOCATE 20 + X%, INT(70 - LEN(PRTL$(16 + X%))) * .5: PRINT PRTL$(16 + X%)
9890 NEXT X%
9900 LOCATE 23, 39: INPUT ANSP$
9910 IF ANSP$ = "" THEN GOTO 4390
9920 IF ANSP$ = "C" OR ANSP$ = "c" THEN 9940
9930 IF ANSP$ <> "c" OR ANSP$ <> "C" OR ANSP$ <> "" THEN 9900
9940 FOR X% = 1 TO 5
9950 LOCATE 18 + X%, 1: PRINT "                                                                               "
9960 NEXT X%
9970 LOCATE 19, 15: INPUT "INPUT FOUR NEW VALUES (NUMBERS 1 TO 13)"; P1%, P2%, P3%, P4%
9980 IF P1% < 1 OR P1% > 13 THEN 9940
9990 IF P2% < 1 OR P2% > 13 THEN 9940
10000 IF P3% < 1 OR P3% > 13 THEN 9940
10010 IF P4% < 1 OR P4% > 13 THEN 9940
10020 GOTO 4390
10030 CLS
10040 FLTL$(1) = "YOU CAN PLOT  4  OF  5  FLOW VALUES vs. TIME"
10050 FLTL$(2) = "YOUR CHOICES ARE :"
10060 FLTL$(3) = "1 - FURNACE FLOW (L/S)"
10070 FLTL$(4) = "2 - DILUTION FLOW (L/S)"
10080 FLTL$(5) = "3 - CHIMNEY FLOW (L/S)"
10090 FLTL$(6) = "4 - AIR FLOW DRAWN THROUGH THE ENVELOPE (L/S)"
10095 FLTL$(7) = "5 - HOT WATER BRANCH FLOW (L/S)"
10097 FLTL$(8) = "YOUR DEFAULT VALUES ARE> "
10100 FLTL$(9) = "PRESS <ENTER> TO SELECT DEFAULT VALUES"
10102 FLTL$(10) = "OR C TO ENTER FOUR NEW OUTPUT VALUES"
10110 LOCATE 4, INT(70 - LEN(FLTL$(1))) * .5: PRINT FLTL$(1)
10120 LOCATE 6, INT(70 - LEN(FLTL$(2))) * .5: PRINT FLTL$(2)
10140 FOR X% = 1 TO 5
10150 LOCATE X% + 7, 20: PRINT FLTL$(X% + 2)
10160 NEXT X%
10161 LOCATE 15, INT(70 - LEN(FLTL$(8))) * .5: PRINT FLTL$(8); : PRINT USING " ##, ##, ##, and ##"; FR1%, FR2%, FR3%, FR4%
10162 FOR X% = 1 TO 2
10164 LOCATE 15 + X%, INT(70 - LEN(FLTL$(8 + X%))) * .5: PRINT FLTL$(8 + X%)
10166 NEXT X%
10168 LOCATE 20, 39: INPUT ANSF$
10170 IF ANSF$ = "" THEN GOTO 4390
10172 IF ANSF$ = "C" OR ANSF$ = "c" THEN 10176
10174 IF ANSF$ <> "c" OR ANSF$ <> "C" OR ANSF$ <> "" THEN 10168
10176 FOR X% = 1 TO 5
10178 LOCATE 15 + X%, 1: PRINT "                                                                   "
10180 NEXT X%
10182 LOCATE 16, 15: INPUT "INPUT FOUR NEW VALUES (NUMBERS 1 TO 5)"; FR1%, FR2%, FR3%, FR4%
10184 IF FR1% < 1 OR FR1% > 5 THEN 10176
10186 IF FR2% < 1 OR FR2% > 5 THEN 10176
10188 IF FR3% < 1 OR FR3% > 5 THEN 10176
10190 IF FR4% < 1 OR FR4% > 5 THEN 10176
10200 GOTO 4390
10210 REM: PAUSE ROUTINE
10220 TTT = TIMER: WHILE TIMER < TTT + 3: WEND
10230 RETURN
10240 REM: SIMPLE QUESTION FORMAT   HDR$=TOP LINE,QN1$=FIRST QUESTION LINE
10250 REM: QN2$=SECOND DESCRIPTOR LINE OR LIMITS  TFLAG=1 FOR TEXT DEFAULT
10260 REM: DEFAULT VALUE IS IN EITHER FAULT(#) OR FAULT$(STRNG%)
10270 REM: NEW INPUT VALUE IS STORED IN NFAULT(#) OR NFAULT$(STRNG%)
10280 STRNG% = 0
10290 IF TFLAG = 0 THEN GOTO 10470
10300 CLS : COLOR 7: PRINT HDR$: PRINT
10310 COLOR 15, 0: PRINT QN1$: COLOR 7: PRINT : PRINT QN2$: PRINT
10320 WHILE TFLAG
10330 PRINT "DEFAULT VALUE IS ";
10340 COLOR 15, 0: PRINT FAULT$
10350 LOCATE 23, 50: PRINT "HIT ENTER KEY TO USE DEFAULT": LOCATE 10, 10
10360 PRINT "INPUT YOUR SELECTION -> ";
10370 COLOR 0, 7: PRINT SPACE$(TLEN): LOCATE 10, 34: INPUT "", NFAULT$: COLOR 7, 0: PRINT
10380 IF NFAULT$ = "" THEN NFAULT$ = FAULT$: GOTO 10440
10390 LOCATE 22, 35: PRINT SPC(30); : LOCATE 15, 1
10400 PRINT "THE VALUE OF THIS ENTRY IS -> "; NFAULT$: PRINT
10410 INPUT "IS THE ENTRY CORRECT?  [Y]/N "; RESP$: IF RESP$ = "" OR RESP$ = "Y" OR RESP$ = "y" THEN GOTO 10440
10420 IF RESP$ = "N" OR RESP$ = "n" THEN GOTO 10260
10430 LOCATE 17, 1: GOTO 10410
10440 TFLAG = 0: STRNG% = 1
10450 WEND
10460 IF STRNG% = 1 THEN RETURN
10470 CLS : COLOR 7: PRINT HDR$: PRINT
10480 COLOR 15, 0: PRINT QN1$: COLOR 7: PRINT : PRINT QN2$: PRINT
10490 PRINT "DEFAULT VALUE IS ";
10500 COLOR 15, 0
10510 IF (INT(FAULT) - FAULT) = 0 THEN PRINT USING "##########"; FAULT: GOTO 10530
10520 COLOR 15, 0: PRINT USING "#####.#####"; FAULT
10530 LOCATE 23, 50: PRINT "HIT ENTER KEY TO USE DEFAULT": LOCATE 10, 10
10540 PRINT "INPUT YOUR SELECTION -> ";
10550 COLOR 15, 0: INPUT NFAULT$: COLOR 7: PRINT
10560 IF NFAULT$ = "" THEN NFAULT = FAULT: RETURN
10570 NFAULT = VAL(NFAULT$)
10580 LOCATE 22, 35: PRINT SPC(30); : LOCATE 15, 1
10590 PRINT USING "THE VALUE OF THIS ENTRY IS ->#####.#####"; NFAULT: PRINT
10600 INPUT "IS THE ENTRY CORRECT?  [Y]/N "; RESP$: IF RESP$ = "" OR RESP$ = "Y" OR RESP$ = "y" THEN RETURN
10610 IF RESP$ = "N" OR RESP$ = "n" THEN GOTO 10470
10620 LOCATE 17, 1: GOTO 10600
10690 PRINT "YOUR ENTRY IS QUESTIONABLE - PLEASE READ QUESTION AND TRY AGAIN. "
10695 T = TIMER: WHILE TIMER < T + 3: WEND: RETURN
10700 '    FLUE PIPE INPUT AIDS
10710 '
10715 CLS : PRINT "           YOUR FLUE PIPE SEGMENT DIMENSION IS NOT CONSISTENT": PRINT "             WITH PREVIOUSLY DEFINED OVERALL DIMENSIONS.": GOTO 10730
10720 CLS : PRINT "YOU HAVE USED ALL YOUR SECTIONS AND THE FLUE PIPE STILL DOES NOT FIT": PRINT "               PLEASE ENTER THE DATA FROM THE BEGINNING": GOTO 10730
10725 CLS : PRINT "       YOU HAVE FITTED THE FLUEPIPE TO THE CHIMNEY AND": PRINT "       YOU STILL HAVE SOME REMAINING SEGMENTS TO DEFINE"
10730 PRINT "PLEASE STUDY THE FOLLOWING TO DETERMINE WHICH DATA SHOULD BE CHANGED ."
10735 LOCATE 6, 35: PRINT " RISE(m)      LENGTH(m)"
10740 FOR I% = 1 TO FPSEG%
10745 IF I% = FPSEG% AND ROR$ = "RISE" THEN PRISE(I%) = NFAULT: LOCATE 6 + I%, 41: PRINT "<---": PRUUN(I%) = 0: GOTO 10760
10750 PRISE(I%) = RISE(I%): PRUUN(I%) = FPLN(I%)
10755 IF I% = FPSEG% AND ROR$ = "LENGTH" THEN PRUUN(I%) = NFAULT: LOCATE 6 + I%, 58: PRINT "<---"
10760 LOCATE 6 + I%, 15: PRINT "      SECTION   "; I%; : PRINT USING "  #.###"; PRISE(I%): LOCATE 6 + I%, 52: PRINT USING " #.###"; PRUUN(I%)
10765 NEXT I%
10770 FOR I% = FPSEG% + 1 TO NFPSEGS%
10775 LOCATE 6 + I%, 15: PRINT "      SECTION   "; I%; : PRINT USING "  #.###          "; 0, 0
10780 NEXT I%
10785 LOCATE 6 + NFPSEGS% + 1, 10: PRINT "TOTAL DEFINED SO FAR"; : PRINT USING "      #.###      "; RISET, FPLNT
10790 LOCATE 6 + NFPSEGS% + 2, 10: PRINT "  OVERALL DIMENSIONS"; : PRINT USING "      #.###      "; RISEMAX; FPLNMAX
10795 LOCATE 6 + NFPSEGS% + 3, 10: PRINT "         DISCREPANCY"; : PRINT USING "      #.###      "; RISEMAX - RISET; FPLNMAX - FPLNT
10800 LOCATE 16, 25: PRINT "DO YOU WANT TO : 1. CHANGE CURRENT INPUT": LOCATE 17, 41: PRINT " 2. START OVER"
10805 LOCATE 19, 25: PRINT " ENTER YOUR CHOICE AND HIT RETURN": LOCATE 20, 25: INPUT " YOUR CHOICE(1/2)"; KB$: IF KB$ = "" THEN GOTO 10805
10810 IF KB$ = "1" THEN GOTO 10840
10815 IF KB$ = "2" THEN STRTOVR$ = "Y": GOTO 10840
10820 GOTO 10805
10825 REM:IF ABS(RISEMAX-RISET)>.01 OR ABS(RUUNMAX-RUUNT)>.01 THEN PRINT"      THE CONFIGURATION DOES NOT FIT WITH THESE DEFAULTS":GOTO 65070
10830 REM:PRINT"CONFIGURATION FITS WITH THESE DEFAULTS"
10835 KB$ = INKEY$: IF KB$ = "" THEN 10835
10840 RETURN
11000 '   ENVELOPE LEAK AND FRESH AIR INTAKE LOCATION
11010 CHM$(6) = "*"
11020 SCRTL$ = "VCLSCR"
11030 NF% = 4
11040 VAR(1) = LNPP
11050 VAR(2) = VCLINT
11060 VAR(3) = ARINT
11070 VAR(4) = NELINT
11080 GOSUB 2000
11090 LNPP = VAL(SI.DATA$(1))
11100 VCLINT = VAL(SI.DATA$(2))
11110 ARINT = VAL(SI.DATA$(3))
11120 NELINT = VAL(SI.DATA$(4))
11130 HDR$ = "DISTRIBUTION OF ENVELOPE LEAKS RELATIVE TO THE WIND DIRECTION"
11140 QN1$ = "ENTER THE SELECTION WHICH BEST DESCRIBES THE ORIENTATION OF ENVELOPE LEAKS": QN2$ = "(1. MAINLY WINDWARD  2. MAINLY LEEWARD  3. PARALLEL  4. UNIFORM  5. SHELTERED)": FAULT = LEAKDIST: GOSUB 10240: IF NFAULT < 1 OR NFAULT > 5 THEN GOSUB _
 10690: GOTO 11140
11150 LEAKDIST = NFAULT
11160 GOTO 5010
12000 REM    FURNACE THERMOSTAT SETPOINT
12010 CHM$(9) = "*"
12550 SCRTL$ = "WHTHRM"
12560 NF% = 6
12562 FOR I% = 1 TO NF%: VAR(I%) = -9997: NEXT
12572 VAR(1) = T9
12574 VAR(2) = TMONOFF
12576 VAR(3) = HVOL
12578 VAR(4) = HTC
12580 VA$(5) = HMASS$
12582 VA$(6) = MDI$
12600 GOSUB 2000
12640 T9 = VAL(SI.DATA$(1))
12650 TMONOFF = VAL(SI.DATA$(2))
12652 HVOL = VAL(SI.DATA$(3))
12654 HTC = VAL(SI.DATA$(4))
12656 HMASS$ = SI.DATA$(5)
12658 MDI$ = SI.DATA$(6)
12660 THS = T9 + (.5 * TMONOFF)
12666 IF HMASS$ = "L" OR HMASS$ = "l" THEN HMASS$ = "L": HHC = 24000! * 1630: GOTO 12669: REM:MASS *SPECIFIC HT OF WOOD
12667 IF HMASS$ = "M" OR HMASS$ = "m" THEN HMASS$ = "M": HHC = 55000! * 1300: GOTO 12669: REM:MASS*SPECIFIC HEAT OF WOOD/BRICK COMPOSITE(ESTIMATED)
12668 IF HMASS$ = "H" OR HMASS$ = "h" THEN HMASS$ = "H": HHC = 100000! * 1000: REM:MASS*SPECIFIC HT OF ALMOST ALL CONCRETE HOUSE(I.E CONCRETE CP=900.ADJUST UPWARD TO ACCOUNT FOR SOME WOOD).
12669 IF MDI$ = "y" THEN MDI$ = "Y"
12700 IF MDI$ = "n" THEN MDI$ = "N"
12702 NFAULT$ = MDI$
12705 IF MDI$ = "Y" THEN GOSUB 12740
12710 MDI$ = NFAULT$
12720 IF MDI$ = "N" THEN DP0 = 0: CNST = 0
12730 GOTO 5010
12740 REM DRAFT INDUCER MODEL DI-1,DI-2 AND DI-3
12750 DIFLAG = 0: REM:FLAG TO INDICATE DRAFT INDUCER HAS NOT BEEN DEFINED YET
12760 PIE = 3.1415179#: DIA = ((AR(5) / PIE) ^ .5) * 2
12770 IF DIA < .075 OR DIA > .33 OR F2 < 20000 OR F2 > 400000! THEN GOTO 12930
12780 IF DIA > .075 AND DIA <= .1 AND F2 <= 20217! THEN CNST = -40000!: DP0 = 29.382: GOTO 12920
12790 IF DIA > .1 AND DIA <= .125 AND F2 <= 30765! THEN CNST = -20000: DP0 = 33.615: GOTO 12920
12800 IF DIA > .125 AND DIA <= .15 AND F2 <= 32523! THEN CNST = -6564: DP0 = 24.586: GOTO 12920
12810 IF DIA > .125 AND DIA <= .15 AND F2 > 32523 AND F2 <= 79110! THEN CNST = -9500: DP0 = 88.39499: GOTO 12920
12820 IF DIA > .15 AND DIA <= .175 AND F2 <= 29300 THEN CNST = -3500: DP0 = 16.932: GOTO 12920
12830 IF DIA > .15 AND DIA <= .175 AND F2 > 29300 AND F2 <= 104308! THEN CNST = -3300: DP0 = 57.893: GOTO 12920
12840 IF DIA > .175 AND DIA <= .2 AND F2 <= 105486! THEN CNST = -879: DP0 = 25.694: GOTO 12920
12850 IF DIA > .2 AND DIA <= .225 AND F2 <= 93760! THEN CNST = -450: DP0 = 29.258: GOTO 12920
12860 IF DIA > .2 AND DIA <= .225 AND F2 <= 263700! THEN CNST = -650: DP0 = 116.042: GOTO 12920
12870 IF DIA > .225 AND DIA <= .25 AND F2 <= 325230! THEN CNST = -188: DP0 = 84.255: GOTO 12920
12880 IF DIA > .25 AND DIA <= .275 AND F2 <= 366250! THEN CNST = -120: DP0 = 67.23001: GOTO 12920
12890 IF DIA > 275 AND DIA <= .3 AND F2 <= 334020! THEN CNST = -56: DP0 = 56.646: GOTO 12920
12900 IF DIA > .3 AND DIA <= .33 AND F2 <= 301790! THEN CNST = -34: DP0 = 47.559: GOTO 12920
12910 IF MDI$ = "Y" THEN GOTO 12940
12920 RETURN
12930 REM :ERROR TRAP FOR DRAFT INDUCERS ROUTINE
12940 CLS : PRINT : PRINT "   A DRAFT INDUCER CANNOT BE DEFINED FOR THIS FURNACE/FLUE CONFIGURATION."
12950 PRINT : PRINT "  THE FOLLOWING RESTRICTIONS APPLY WHEN DEFINING A DRAFT INDUCER": PRINT "1) THE DIAMETER OF THE FLUPIPE MUST BE BETWEEN 0.075 m2 AND 0.33 m2"
12960 PRINT "2) THE FURNACE INPUT MUST BE BETWEEN 20000 WATTS AND 400000 WATTS"
12970 PRINT : PRINT : PRINT "YOUR INPUTS ARE:"
12980 PRINT USING "DIAMETER: #.###  m2"; DIA: PRINT USING "FURNACE INPUT: ######   WATTS"; F2
12990 PRINT : PRINT : PRINT "  PLEASE REFER TO THE MANUAL FOR FURTHER INFORMATION ON THIS ROUTINE"
13000 PRINT "                    PRESS ANY KEY TO CONTINUE"
13010 NFAULT$ = "N"
13020 KB$ = INKEY$: IF KB$ = "" THEN 13020 ELSE 13030
13030 RETURN
14000 REM   DOMESTIC HOT WATER HEATER SPECIFICATIONS
14010 CHM$(7) = "*"
14020 SCRTL$ = "DHW"
14030 NF% = 11
14040 FOR I% = 1 TO NF%: VAR(I%) = -9997: NEXT
14050 IF DHWAR = 0! THEN DHWC = 0!
14055 IF DHWC = 0 AND DHWSBC = 0 THEN DHW$ = "N" ELSE DHW$ = "Y"
14057 VA$(1) = DHW$
14058 VA$(2) = DHWO$
14060 VAR(3) = DHWC
14070 VAR(4) = DHWSBC
14080 VAR(5) = DHWEF * 100!
14090 VAR(6) = DHWAR
14100 VAR(7) = DHWFPLE
14110 VAR(8) = DHWFPH
14115 VAR(9) = DHWNEL
14120 VA$(10) = DHWTYPE$
14130 VAR(11) = DHWFPN
14140 GOSUB 2000
14145 DHW$ = SI.DATA$(1)
14147 DHWO$ = SI.DATA$(2)
14150 DHWC = VAL(SI.DATA$(3))
14160 DHWSBC = VAL(SI.DATA$(4))
14170 DHWEF = VAL(SI.DATA$(5)) / 100!
14180 DHWAR = VAL(SI.DATA$(6))
14190 DHWFPLE = VAL(SI.DATA$(7))
14200 DHWFPH = VAL(SI.DATA$(8))
14205 DHWNEL = VAL(SI.DATA$(9))
14210 DHWTYPE$ = SI.DATA$(10)
14220 DHWFPN = VAL(SI.DATA$(11))
14230 IF DHWAR = 0! THEN DHWC = 0!
14231 IF DHW$ = "N" OR DHW$ = "n" THEN DHWC = 0: DHWSBC = 0
14232 IF DHWO$ = "o" THEN DHWO$ = "O"
14233 IF DHWO$ = "s" THEN DHWO$ = "S"
14234 IF DHWTYPE$ = "t" THEN DHWTYPE$ = "T"
14235 IF DHW$ = "N" OR DHW$ = "n" THEN DHWC = 0: DHWSBC = 0
14236 IF DHWTYPE$ = "y" THEN DHWTYPE$ = "Y"
14237 IF DHWTYPE$ = "b" THEN DHWTYPE$ = "B"
14240 GOTO 5010
15000 REM     FLUE DAMPER AND FLUE CAPS
15010 CHM$(8) = "*"
15020 SCRTL$ = "DAMCAP"
15030 NF% = 10
15040 FOR I% = 1 TO NF%: VAR(I%) = -9997: NEXT
15050 VA$(1) = FDAMP$
15052 VA$(2) = DAMPACT$
15054 VAR(3) = DAMPTOP
15056 VAR(4) = DAMPTCL
15060 VAR(5) = ARDAMP
15070 VAR(6) = PHC
15072 VAR(7) = THETAW
15074 VAR(8) = PTC
15075 VAR(9) = VWINDT
15076 VAR(10) = FCAPL
15080 GOSUB 2000
15090 FDAMP$ = SI.DATA$(1)
15092 DAMPACT$ = SI.DATA$(2)
15094 DAMPTOP = VAL(SI.DATA$(3))
15096 DAMPTCL = VAL(SI.DATA$(4))
15100 ARDAMP = VAL(SI.DATA$(5))
15102 PHC = VAL(SI.DATA$(6))
15104 THETAW = VAL(SI.DATA$(7))
15106 PTC = VAL(SI.DATA$(8))
15108 VWINDT = VAL(SI.DATA$(9))
15110 FCAPL = VAL(SI.DATA$(10))
15120 IF FDAMP$ = "Y" OR FDAMP$ = "y" THEN FDAMP$ = "Y" ELSE FDAMP$ = "N"
15125 IF DAMPACT$ = "e" THEN DAMPACT$ = "E"
15126 IF DAMPACT$ = "t" THEN DAMPACT$ = "T"
15130 VWINDH = VWINDT * COS(THETAW * 3.141593 / 180!)
15140 VWINDV = VWINDT * SIN(THETAW * 3.141593 / 180!)
15150 GOTO 5010

29000 REM *** USER ERROR HANDLING ROUTINES ***
29100 REM:  ERROR HANDLING ROUTINES
29110 COLOR 7
29120 IF ERR = 27 OR ERR = 24 THEN LOCATE 20, 40: PRINT "CHECK PRINTER": RESUME
29130 IF ERR = 61 THEN LOCATE 10, 40: PRINT "DISK IS FULL - USE ANOTHER DISKETTE": LOCATE 20, 1: PRINT SPACE$(79): PRINT SPACE$(79): RESUME 4750
29140 IF ERR = 53 AND ERL = 112 THEN GOTO 30000
29999 ON ERROR GOTO 0
30000 BEEP: CLS : LOCATE 5, 5: PRINT "In order to proceed, it is necessary that the file"
30010 LOCATE 7, 5: PRINT "'INSTALL5.DAT' be in the current drive/directory."
30020 LOCATE 14, 5: PRINT "DO YOU WISH TO -"
30030 LOCATE 16, 1: PRINT "1. EXIT to DOS to copy 'INSTALL5.DAT' to the current drive/directory"
30040 LOCATE 18, 1: PRINT "2. RUN the INSTALL program to create 'INSTALL5.DAT'"
30050 LOCATE 20, 10: INPUT "Your choice  1 or 2"; A
30060 IF A = 2 THEN RUN "INSTALL5" ELSE GOTO 600
'$INCLUDE: 'SCREEN5.BAS'

SUB InputFiles
CLS
FileSpec$ = INDRIVE$ + "*.FM5"
FCount FileSpec$, COUNT%                 'returns number of matching files
					'  plus one more for the end marker
FOR X% = 1 TO COUNT% + 1                 'reserve room for each name
   FileName$(X%) = SPACE$(12)
NEXT
FileName$(0) = FileSpec$                'tell BasDir which files to get
BasDir VARPTR(FileName$(0))
'SORT
       FOR X% = 1 TO COUNT%
       XX% = X%
       FOR XXX% = XX% TO COUNT%
       IF FileName$(X%) > FileName$(XXX%) THEN
       TEMP$ = FileName$(X%)
       FileName$(X%) = FileName$(XXX%)
       FileName$(XXX%) = TEMP$
       END IF
       NEXT
       NEXT

   
     HDR$ = "FLUESIM FILE LOADING ROUTINE": CLS : COLOR 15, 0: PRINT HDR$: PRINT
begin:   LOCATE 2, 1: PRINT "Choose the desired Default Data File from the following list:": PRINT : COLOR 7, 0
   
	  FOR X% = 1 TO COUNT%
	  XC% = X% \ 15 + 1: XR% = X% MOD 15: IF XR% = 0 THEN XR% = 15: XC% = XC% - 1
	  A% = 4 + XR%: B% = 5 + (19 * (XC% - 1))
	  LOCATE A%, B%
	  PRINT USING "##  &"; X%; FileName$(X%)
	  NEXT
	  PRINT
	
     LOCATE 22, 5: COLOR 15, 0
     INPUT "Enter the NUMBER of the file to be loaded -->"; XX
     COLOR 7, 0
     IF XX < 1 OR XX > COUNT% THEN GOTO begin
   
     FLE$ = FileName$(XX)
     CHK$ = ".": LOCDOT = INSTR(FLE$, CHK$): FAULT$ = LEFT$(FLE$, LOCDOT - 1)
     PRINT : LOCATE , 10: PRINT "LOADING: "; FLE$
     DefaultFile$ = FAULT$
endinfiles:

END SUB

